<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ZoneInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ZoneInfo extends AbstractStructArrayBase
{
    /**
     * The ZoneInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ZoneInfo[]
     */
    public $ZoneInfo;
    /**
     * Constructor method for ArrayOfJP_ZoneInfo
     * @uses ArrayOfJP_ZoneInfo::setZoneInfo()
     * @param \StructType\JP_ZoneInfo[] $zoneInfo
     */
    public function __construct(array $zoneInfo = array())
    {
        $this
            ->setZoneInfo($zoneInfo);
    }
    /**
     * Get ZoneInfo value
     * @return \StructType\JP_ZoneInfo[]|null
     */
    public function getZoneInfo()
    {
        return $this->ZoneInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setZoneInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setZoneInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateZoneInfoForArrayConstraintsFromSetZoneInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_ZoneInfoZoneInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ZoneInfoZoneInfoItem instanceof \StructType\JP_ZoneInfo) {
                $invalidValues[] = is_object($arrayOfJP_ZoneInfoZoneInfoItem) ? get_class($arrayOfJP_ZoneInfoZoneInfoItem) : sprintf('%s(%s)', gettype($arrayOfJP_ZoneInfoZoneInfoItem), var_export($arrayOfJP_ZoneInfoZoneInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ZoneInfo property can only contain items of type \StructType\JP_ZoneInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ZoneInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ZoneInfo[] $zoneInfo
     * @return \ArrayType\ArrayOfJP_ZoneInfo
     */
    public function setZoneInfo(array $zoneInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($zoneInfoArrayErrorMessage = self::validateZoneInfoForArrayConstraintsFromSetZoneInfo($zoneInfo))) {
            throw new \InvalidArgumentException($zoneInfoArrayErrorMessage, __LINE__);
        }
        $this->ZoneInfo = $zoneInfo;
        return $this;
    }
    /**
     * Add item to ZoneInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ZoneInfo $item
     * @return \ArrayType\ArrayOfJP_ZoneInfo
     */
    public function addToZoneInfo(\StructType\JP_ZoneInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ZoneInfo) {
            throw new \InvalidArgumentException(sprintf('The ZoneInfo property can only contain items of type \StructType\JP_ZoneInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ZoneInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ZoneInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ZoneInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ZoneInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ZoneInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ZoneInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ZoneInfo
     */
    public function getAttributeName()
    {
        return 'ZoneInfo';
    }
}
